from typing import Generic, TypeVar

from rainbowadn.data.collection.trees.binary.binarytreecreationprotocol import BinaryTreeCreationProtocol
from rainbowadn.data.collection.trees.binary.binarytreesplit import BinaryTreeSplit

__all__ = ('BinaryTreeCase',)

TreeType = TypeVar('TreeType')
ActiveKeyType = TypeVar('ActiveKeyType')
MetaDataType = TypeVar('MetaDataType')


class BinaryTreeCase(
    Generic[ActiveKeyType, MetaDataType, TreeType]
):
    def __init__(
            self,
            protocol: BinaryTreeCreationProtocol[ActiveKeyType, MetaDataType, TreeType],
            split: BinaryTreeSplit[ActiveKeyType, MetaDataType, TreeType],
            tree: TreeType
    ):
        self.protocol = protocol
        self.split = split
        self.tree = tree
